<?php
/**************************************************************************************
* MetaTags.php                                                                        *
***************************************************************************************
* MetaTags Modification Version 2.0.2 for SMF                                         *
* =================================================================================== *
* Modification from SID-Giessen (http://www.sid-giessen.de)                           *
* For SMF:        SMF 2.0 Beta 4, SMF 2.0 RC1, SMF 2.0 RC1-1, SMF 2.0 RC1.2,          *
*                 SMF 2.0 RC2, SMF 2.0 RC3, SMF 2.0 RC4, SMF 2.0 RC5, SMF 2.0,        *
*                 SMF 2.0.1, SMF 2.0.2, SMF 2.0.3                                     *
* Support:        http://forum.sid-giessen.de                                         *
**************************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

function MetaTagsSpecialChars ($text)
{
	return str_replace('"', '&quot;', strip_tags(html_entity_decode($text, ENT_QUOTES)));
}

function MetaTagsGenerateTeaser ($id_msg)
{
	global $smcFunc;

	$request = $smcFunc['db_query']('', '
		SELECT body
		FROM {db_prefix}messages
		WHERE id_msg = {int:id_msg}',
		array(
			'id_msg' => $id_msg
		));

	list ($teaser) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	// Format as a plain text string.
	$teaser = MetaTagsSpecialChars(str_replace('<br />', ' ', parse_bbc($teaser)));

	// Less than the teasear limit, just return.
	if(strlen($teaser) < 150)
		return $teaser;

	// Otherwise grab the teaser.
	$teaser = substr($teaser, 0, 150);
	return substr($teaser, 0, strrpos($teaser, ' '));
}

?>
